Package: multilevelmod
Title: Model Wrappers for Multi-Level Models
Version: 1.0.0
Authors@R: c(
    person("Max", "Kuhn", , "max@rstudio.com", role = c("aut"),
           comment = c(ORCID = "0000-0003-2402-136X")),
           person("Hannah", "Frick", , "hannah@rstudio.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-6049-5258")),
    person("RStudio", role = c("cph", "fnd"))
  )
Description: Bindings for hierarchical regression models for use with the
    'parsnip' package. Models include longitudinal generalized linear
    models (Liang and Zeger, 1986) <doi:10.1093/biomet/73.1.13>, and
    mixed-effect models (Pinheiro and Bates)
    <doi:10.1007/978-1-4419-0318-1_1>.
License: MIT + file LICENSE
URL: https://github.com/tidymodels/multilevelmod,
        http://multilevelmod.tidymodels.org/
Depends: parsnip (>= 1.0.0), R (>= 2.10)
Imports: dplyr, lme4, purrr, rlang, tibble, withr
Suggests: covr, gee, ggplot2, knitr, nlme, rmarkdown, spelling,
        testthat, tidymodels
VignetteBuilder: knitr
Config/Needs/website: tidymodels/tidymodels, tidyverse/tidytemplate
Encoding: UTF-8
Language: en-US
LazyData: true
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.2.0
Author: Max Kuhn [aut] (<https://orcid.org/0000-0003-2402-136X>),
  Hannah Frick [aut, cre] (<https://orcid.org/0000-0002-6049-5258>),
  RStudio [cph, fnd]
Maintainer: Hannah Frick <hannah@rstudio.com>
Built: R 4.4.0; ; 2024-05-08 09:38:51 UTC; unix

data(riesby)

# ------------------------------------------------------------------------------

riesby_tr <- riesby[-(1:8), ]
riesby_te <- riesby[ (1:8), c("week", "imipramine")]
riesby_te$subject <- "1000"

f <- depr_score ~ week + imipramine + (1 | subject)

# ------------------------------------------------------------------------------

riesby_bin <- riesby
riesby_bin$depressed <- ifelse(riesby_bin$depr_score < -10, "low", "high")
riesby_bin$depressed <- factor(riesby_bin$depressed)
riesby_bin$binary <- ifelse(riesby_bin$depr_score < -10, 1, 0)
riesby_bin_tr <- riesby_bin[-(1:8), ]
riesby_bin_te <- riesby_bin[ (1:8), c("week", "imipramine")]
riesby_bin_te$subject <- "1000"

f_bin <- depressed ~ week + imipramine + (1 | subject)

# ------------------------------------------------------------------------------

counts_tr <- longitudinal_counts[-(1:10), ]
counts_te <- longitudinal_counts[ (1:10), c("time", "x", "subject")]
counts_te$subject <- "1000"

f_counts <- y ~ time + x + (1 | subject)

test_that('lme4 execution', {
  skip_if_not_installed("lme4")
  skip_on_cran()

  lme4_cl <- call2("lmer", .ns = "lme4", f, data = expr(riesby_tr))

  set.seed(2452)
  lme4_mod <- eval_tidy(lme4_cl)

  set.seed(2452)
  expect_error(
    ps_mod <-
      linear_reg() %>%
      set_engine("lmer") %>%
      fit(f, data = riesby_tr),
    regex = NA
  )

  expect_equal(
    coef(ps_mod$fit)$subject,
    coef(lme4_mod)$subject
  )

  lme4_pred <- predict(lme4_mod, riesby_te, allow.new.levels = TRUE)

  ps_pred <- predict(ps_mod, riesby_te)

  expect_equal(unname(lme4_pred), ps_pred$.pred)

})


test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "lmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "lmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("lme4", "multilevelmod"))
  )
})


test_that('random interactions and/or nesting', {
  skip_if_not_installed("lme4")
  skip_if_not_installed("ggplot2")
  skip_on_cran()

  data(mpg, package = "ggplot2")

  fit <-
    linear_reg() %>%
    set_engine("lmer") %>%
    fit(cty ~ year + (1|manufacturer/model), data = mpg)

  expect_error(predict(fit, new_data = mpg), regexp = NA)
  # Now predict with new levels for the random effect columns, esp
  # when there is nesting/interactions
  expect_error(
    predict(fit, new_data = tibble::tibble(year = 2000, model = "dan", manufacturer = "max")),
    regexp = NA
  )



})

test_that('logistic glmer execution', {
  skip_if_not_installed("lme4")
  skip_on_cran()

  # ----------------------------------------------------------------------------

  # Run both regular and glmer model
  set.seed(1234)
  glmer_mod <- lme4::glmer(f_bin, family = binomial, data = riesby_bin_tr)

  # ----------------------------------------------------------------------------

  # Check for error
  expect_error(
    ps_mod <-
      logistic_reg() %>%
      set_engine("glmer") %>%
      fit(f_bin, data = riesby_bin_tr),
    regex = NA
  )

  # ----------------------------------------------------------------------------

  # See if coefficients for both model runs are the same
  expect_equal(
    coef(ps_mod$fit),
    coef(glmer_mod)
  )

  # ----------------------------------------------------------------------------

  glmer_prob <- unname(predict(glmer_mod, riesby_bin_te, type = "response",
                               allow.new.levels = TRUE))
  pa_prob <- predict(ps_mod, riesby_bin_te, type = "prob")
  expect_equal(
    glmer_prob,
    pa_prob$.pred_low
  )

  glmer_cls <- ifelse(glmer_prob > 0.5, "low", "high")
  glmer_cls <- factor(glmer_cls, levels = levels(riesby_bin_tr$depressed))
  pa_cls <- predict(ps_mod, riesby_bin_te, type = "class")
  expect_equal(
    glmer_cls,
    pa_cls$.pred_class
  )
})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list(c("lme4", "multilevelmod"))
  )

  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list()
  )
})

test_that('logistic gee execution', {
  skip_if_not_installed("gee")
  skip_on_cran()

  # ----------------------------------------------------------------------------

  # Run both regular and GEE model
  set.seed(1234)
  gee_mod <- gee::gee(binary ~ week + imipramine, id = riesby_bin_tr$subject,
                      family = binomial, data = riesby_bin_tr)
  # gee doesn't have all of the elements that are needed from prediction. Get
  # them from glm
  glm_mod <- glm(binary ~ week + imipramine,  data = riesby_bin_tr, family = binomial)
  gee_mod$rank <- glm_mod$rank
  gee_mod$qr <- glm_mod$qr
  class(gee_mod) <- c(class(gee_mod), "lm")

  # ----------------------------------------------------------------------------

  # Check for error
  expect_error(
    ps_mod <-
      logistic_reg() %>%
      set_engine("gee") %>%
      fit(depressed ~ week + imipramine + id_var(subject), data = riesby_bin_tr),
    regex = NA
  )

  # ----------------------------------------------------------------------------

  # See if coefficients for both model runs are the same
  expect_equal(
    coef(ps_mod$fit),
    coef(gee_mod)
  )

  # ----------------------------------------------------------------------------

  gee_prob <- unname(predict(gee_mod, riesby_bin_te, type = "response"))
  pa_prob <- predict(ps_mod, riesby_bin_te, type = "prob")
  expect_equal(
    gee_prob,
    pa_prob$.pred_low
  )

  gee_cls <- ifelse(gee_prob > 0.5, "low", "high")
  gee_cls <- factor(gee_cls, levels = levels(riesby_bin_tr$depressed))
  pa_cls <- predict(ps_mod, riesby_bin_te, type = "class")
  expect_equal(
    gee_cls,
    pa_cls$.pred_class
  )

})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "classification") %>%
      dplyr::pull(pkg),
    list(c("gee", "multilevelmod"))
  )

  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "regression") %>%
      dplyr::pull(pkg),
    list()
  )
})

test_that('poisson gee execution', {
  skip_if_not_installed("gee")
  skip_on_cran()

  # ----------------------------------------------------------------------------

  # Run both regular and GEE model
  set.seed(1234)
  gee_mod <- gee::gee(y ~ time + x, id = counts_tr$subject,
                      family = poisson, data = counts_tr)
  # gee doesn't have all of the elements that are needed from prediction. Get
  # them from glm
  glm_mod <- glm(y ~ time + x,  data = counts_tr, family = poisson)
  gee_mod$rank <- glm_mod$rank
  gee_mod$qr <- glm_mod$qr
  class(gee_mod) <- c(class(gee_mod), "lm")

  # ----------------------------------------------------------------------------

  # Check for error
  expect_error(
    ps_mod <-
      poisson_reg(engine = "gee") %>%
      set_engine("gee") %>%
      fit(y ~ time + x + id_var(subject), data = counts_tr),
    regex = NA
  )

  # See if coefficients for both model runs are the same
  expect_equal(
    coef(ps_mod$fit),
    coef(gee_mod)
  )

  # Check predictions
  expect_equal(
    unname(predict(gee_mod, counts_te, type = "response")),
    predict(ps_mod, counts_te)$.pred
  )
})


test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("gee", "multilevelmod"))
  )
})

test_that('logistic stan_glmer execution', {
  skip_if_not_installed("rstanarm")
  skip_on_cran()

  # ----------------------------------------------------------------------------

  stan_cl <- call2("stan_glmer", .ns = "rstanarm", f_bin,
                   data = expr(riesby_bin_tr), seed = 9284, iter = 500, refresh = 0,
                   family = binomial)
  set.seed(1)
  stan_fit <- eval_tidy(stan_cl)

  # ----------------------------------------------------------------------------

  # Check for error
  expect_error({
    set.seed(1)
    ps_mod <-
      logistic_reg() %>%
      set_engine("stan_glmer", seed = 9284, iter = 500, refresh = 0) %>%
      fit(f_bin, data = riesby_bin_tr)
  },
  regex = NA
  )

  # ----------------------------------------------------------------------------

  # See if coefficients for both model runs are the same
  expect_equal(
    coef(ps_mod$fit),
    coef(stan_fit)
  )

  # ----------------------------------------------------------------------------

  stan_cl <- call2("posterior_predict", .ns = "rstanarm", expr(stan_fit),
                   expr(riesby_bin_te), type = "response", seed = 1)
  set.seed(1)
  glmer_prob <- eval_tidy(stan_cl)
  glmer_prob <- apply(glmer_prob, 2, mean)
  set.seed(1)
  pa_prob <- predict(ps_mod, riesby_bin_te, type = "prob")
  expect_equal(
    unname(glmer_prob),
    pa_prob$.pred_low,
    tolerance = .1
  )

  glmer_cls <- ifelse(glmer_prob > 0.5, "low", "high")
  glmer_cls <- factor(glmer_cls, levels = levels(riesby_bin_tr$depressed))
  pa_cls <- predict(ps_mod, riesby_bin_te, type = "class")
  expect_equal(
    unname(glmer_cls),
    pa_cls$.pred_class
  )

})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "stan_glmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list(c("rstanarm", "multilevelmod"))
  )

  expect_identical(
    get_from_env(paste0("logistic_reg", "_pkgs")) %>%
      dplyr::filter(engine == "stan_glmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list()
  )
})

test_that('stan_glm execution', {
  skip_if_not_installed("rstanarm")
  skip_on_cran()

  stan_cl <- call2("stan_glmer", .ns = "rstanarm",
                   f_counts, data = expr(counts_tr), seed = 9284, iter = 500,
                   refresh = 0, family = poisson)

  set.seed(2452)
  expect_warning(stan_mod <- eval_tidy(stan_cl), "ESS")

  expect_warning({
    set.seed(2452)
    expect_error(
      ps_mod <-
        poisson_reg(engine = "stan_glmer") %>%
        set_engine("stan_glmer", seed = 9284, refresh = 0, iter = 500) %>%
        fit(f_counts, data = counts_tr),
      regex = NA
    )
  },
  "ESS"
  )

  expect_equal(
    coef(ps_mod$fit)$subject,
    coef(stan_mod)$subject
  )

  pred_cl <- call2("posterior_predict", .ns = "rstanarm",
                   stan_mod, counts_te)

  set.seed(124321)
  stan_post <- eval_tidy(pred_cl)
  stan_pred <- unname(apply(stan_post, 2, mean))
  stan_pi_lower <- unname(apply(stan_post, 2, quantile, probs = 0.05))
  stan_pi_upper <- unname(apply(stan_post, 2, quantile, probs = 0.95))

  set.seed(124321)
  ps_pred <- predict(ps_mod, counts_te)

  expect_equal(stan_pred, ps_pred$.pred, tolerance = 0.1)

  set.seed(124321)
  ps_pred_int <- predict(ps_mod, counts_te, level = 0.90, type = "pred_int")

  expect_equal(stan_pi_lower, ps_pred_int$.pred_lower, tolerance = 0.1)
  expect_equal(stan_pi_upper, ps_pred_int$.pred_upper, tolerance = 0.1)

})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "stan_glmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "stan_glmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("rstanarm", "multilevelmod"))
  )
})

test_that('linear gee execution', {
  skip_if_not_installed("gee")
  skip_on_cran()

  # ----------------------------------------------------------------------------

  # Run both regular and GEE model
  set.seed(1234)
  gee_mod <- gee::gee(depr_score ~ week, id = riesby_tr$subject,
                      family = quasi, data = riesby_tr)
  # gee doesn't have all of the elements that are needed from prediction. Get
  # them from glm
  glm_mod <- glm(depr_score ~ week,  data = riesby_tr)
  gee_mod$rank <- glm_mod$rank
  gee_mod$qr <- glm_mod$qr
  class(gee_mod) <- c(class(gee_mod), "lm")

  # ----------------------------------------------------------------------------

  # Check for error
  expect_error(
    ps_mod <-
      linear_reg() %>%
      set_engine("gee", family = quasi) %>%
      fit(depr_score ~ week + id_var(subject), data = riesby_tr),
    regex = NA
  )

  # See if coefficients for both model runs are the same
  expect_equal(
    coef(ps_mod$fit),
    coef(gee_mod)
  )

  # Check predictions
  expect_equal(
    unname(predict(gee_mod, riesby_te)),
    predict(ps_mod, riesby_te)$.pred
  )
})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gee", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("gee", "multilevelmod"))
  )
})

test_that('gls execution', {
  skip_if_not_installed("nlme")
  skip_on_cran()

  set.seed(2452)
  gls_mod <-
    nlme::gls(depr_score ~ week + imipramine,
              data = riesby_tr,
              correlation  = nlme::corSymm(form = ~ 1 | subject))

  set.seed(2452)
  expect_error(
    ps_mod <-
      linear_reg() %>%
      set_engine("gls", correlation  = nlme::corSymm(form = ~ 1 | subject)) %>%
      fit(depr_score ~ week + imipramine, data = riesby_tr),
    regex = NA
  )

  expect_equal(
    gls_mod$modelStruct,
    ps_mod$fit$modelStruct
  )
  expect_equal(
    coef(ps_mod$fit),
    coef(gls_mod)
  )

  gls_pred <- predict(gls_mod, riesby_te, level = 0)

  ps_pred <- predict(ps_mod, riesby_te)

  expect_equal(as.numeric(gls_pred), ps_pred$.pred)

})

test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gls", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "gls", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("nlme", "multilevelmod"))
  )
})

test_that('glmer execution', {
  skip_if_not_installed("lme4")
  skip_on_cran()

  glmer_cl <- call2("glmer", .ns = "lme4", f, data = expr(riesby_tr), family = gaussian(make.link("identity")))

  set.seed(2452)
  glmer_mod <- eval_tidy(glmer_cl)

  set.seed(2452)
  expect_error(
    ps_mod <-
      linear_reg() %>%
      set_engine("glmer", family = gaussian(make.link("identity"))) %>%
      fit(f, data = riesby_tr),
    regex = NA
  )

  expect_equal(
    coef(ps_mod$fit)$subject,
    coef(glmer_mod)$subject
  )

  glmer_pred <- predict(glmer_mod, riesby_te, allow.new.levels = TRUE)

  ps_pred <- predict(ps_mod, riesby_te)

  expect_equal(unname(glmer_pred), ps_pred$.pred)

})


test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("linear_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("lme4", "multilevelmod"))
  )
})

test_that('lme4 execution', {
  skip_if_not_installed("rstanarm")
  skip_on_cran()

  lme4_cl <- call2("lmer", .ns = "lme4",
                   f_counts,
                   data = expr(counts_tr))

  set.seed(2452)
  lme4_mod <- eval_tidy(lme4_cl)

  set.seed(2452)
  expect_error(
    ps_mod <-
      linear_reg() %>%
      set_engine("lmer") %>%
      fit(f_counts, data = counts_tr),
    regex = NA
  )

  expect_equal(
    coef(ps_mod$fit)$subject,
    coef(lme4_mod)$subject
  )

  lme4_pred <- predict(lme4_mod, counts_te, allow.new.levels = TRUE)

  ps_pred <- predict(ps_mod, counts_te)

  expect_equal(unname(lme4_pred), ps_pred$.pred)

})


test_that('mode specific package dependencies', {
  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "classification") %>%
      dplyr::pull(pkg),
    list()
  )

  expect_identical(
    get_from_env(paste0("poisson_reg", "_pkgs")) %>%
      dplyr::filter(engine == "glmer", mode == "regression") %>%
      dplyr::pull(pkg),
    list(c("lme4", "multilevelmod"))
  )
})
